javax.validation.metadata

## Interface ExecutableDescriptor

- All Superinterfaces:
    ElementDescriptor
  All Known Subinterfaces:
    ConstructorDescriptor, MethodDescriptor

      public interface ExecutableDescriptor
      extends ElementDescriptor

  Provides the common functionality of `MethodDescriptor` and `ConstructorDescriptor`.
  Since:
    1.1
  Author:
    Gunnar Morling

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface javax.validation.metadata.ElementDescriptor

      `ElementDescriptor.ConstraintFinder`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ElementDescriptor.ConstraintFinder` | `findConstraints()` Returns a finder that will always return an empty `Set`.
    `Set<ConstraintDescriptor<?>>` | `getConstraintDescriptors()` Returns an empty `Set`.
    `CrossParameterDescriptor` | `getCrossParameterDescriptor()` Returns a descriptor containing the cross-parameter constraints of this executable.
    `String` | `getName()` Returns the method name in case this descriptor represents a method or the non-qualified name of the declaring class in case this descriptor represents a constructor.
    `List<ParameterDescriptor>` | `getParameterDescriptors()` Returns a list of descriptors representing this executable's parameters, in the order of their declaration, including synthetic parameters.
    `ReturnValueDescriptor` | `getReturnValueDescriptor()` Returns a descriptor for this executable's return value.
    `boolean` | `hasConstrainedParameters()` Returns `true` if the executable parameters are constrained either: because of a constraint on at least one of the parameters because of a cascade on at least one of the parameters (via `Valid`) because of at least one cross-parameter constraint Also returns `false` if there is no parameter.
    `boolean` | `hasConstrainedReturnValue()` Returns `true` if the executable return value is constrained either: because of a constraint on the return value because validation is cascaded on the return value (via `Valid`) Also returns `false` if there is no return value.
    `boolean` | `hasConstraints()` Returns `false`.

    - ### Methods inherited from interface javax.validation.metadata.ElementDescriptor

      `getElementClass`

- - ### Method Detail

    - #### getName

          String getName()

      Returns the method name in case this descriptor represents a method or the non-qualified name of the declaring class in case this descriptor represents a constructor.
      Returns:
        the name of the executable represented by this descriptor

    - #### getParameterDescriptors

          List<ParameterDescriptor> getParameterDescriptors()

      Returns a list of descriptors representing this executable's parameters, in the order of their declaration, including synthetic parameters.
      Returns:
        a list of descriptors representing this executable's parameters; an empty list will be returned if this executable has no parameters, but never `null`

    - #### getCrossParameterDescriptor

          CrossParameterDescriptor getCrossParameterDescriptor()

      Returns a descriptor containing the cross-parameter constraints of this executable.
      Returns:
        a descriptor containing the cross-parameter constraints of this executable

    - #### getReturnValueDescriptor

          ReturnValueDescriptor getReturnValueDescriptor()

      Returns a descriptor for this executable's return value.

      An executable without return value will return a descriptor representing `void`. This descriptor will have no constraint associated.
      Returns:
        a descriptor for this executable's return value

    - #### hasConstrainedParameters

          boolean hasConstrainedParameters()

      Returns `true` if the executable parameters are constrained either:
      - because of a constraint on at least one of the parameters
      - because of a cascade on at least one of the parameters (via `Valid`)
      - because of at least one cross-parameter constraint

      Also returns `false` if there is no parameter.
      Returns:
        `true` if the executable parameters are constrained

    - #### hasConstrainedReturnValue

          boolean hasConstrainedReturnValue()

      Returns `true` if the executable return value is constrained either:
      - because of a constraint on the return value
      - because validation is cascaded on the return value (via `Valid`)

      Also returns `false` if there is no return value.
      Returns:
        `true` if the executable return value is constrained

    - #### hasConstraints

          boolean hasConstraints()

      Returns `false`.

      An executable per se does not host constraints, use `getParameterDescriptors()`, `getCrossParameterDescriptor()` and `getReturnValueDescriptor()` to discover constraints.
      Specified by:
        `hasConstraints` in interface `ElementDescriptor`
      Returns:
        `false`

    - #### getConstraintDescriptors

          Set<ConstraintDescriptor<?>> getConstraintDescriptors()

      Returns an empty `Set`.

      An executable per se does not host constraints, use `getParameterDescriptors()`, `getCrossParameterDescriptor()` and `getReturnValueDescriptor()` to discover constraints.
      Specified by:
        `getConstraintDescriptors` in interface `ElementDescriptor`
      Returns:
        an empty `Set`

    - #### findConstraints

          ElementDescriptor.ConstraintFinder findConstraints()

      Returns a finder that will always return an empty `Set`.

      An executable per se does not host constraints, use `getParameterDescriptors()`, `getCrossParameterDescriptor()` and `getReturnValueDescriptor()` to discover constraints.
      Specified by:
        `findConstraints` in interface `ElementDescriptor`
      Returns:
        `ConstraintFinder` object

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.